unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, DXClass, DXSprite, DXInput, DXDraws;

type
  TForm1 = class(TForm)
    DXImageList: TDXImageList;
    DXInput: TDXInput;
    DXSpriteEngine: TDXSpriteEngine;
    DXTimer: TDXTimer;
    DXDraw: TDXDraw;
    procedure FormCreate(Sender: TObject);
    procedure DXTimerTimer(Sender: TObject; LagCount: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  S:string;
  hero, brix: TImageSprite;
implementation

{$R *.dfm}
type
  THero = class(TImageSprite)
   Angle:integer;
  protected
    procedure DoCollision(Sprite: TSprite; var Done: Boolean); override;
    procedure DoMove(MoveCount: Integer); override;
    procedure DoDraw; override;
   end;

  TBrix = class(TImageSprite)
  end;
procedure TForm1.FormCreate(Sender: TObject);
begin

  Hero := THero.Create(DXSpriteEngine.Engine);
  with THero(Hero) do
  begin
    Image := DXImageList.Items.Find('hero');
    Collisioned:=true;
    pixelcheck:=true;
    Z := 0;
    Width := Image.Width;
    Height := Image.Height;
    x:=50;
    y:=50;
      end;

  Brix := TBrix.Create(DXSpriteEngine.Engine);
  with TBrix(Brix) do
  begin
    Image := DXImageList.Items.Find('brix');
    Collisioned:=true;
    pixelcheck:=true;
    Z := 0;
    Width := Image.Width;
    Height := Image.Height;
    x:=180;
    y:=150;
      end;
DXInput.Keyboard.KeyAssigns[isButton3,0]:= ord('Q');
DXInput.Keyboard.KeyAssigns[isButton4,0]:= ord('W');


end;
procedure Thero.DoMove(MoveCount: Integer);
begin
  inherited DoMove(MoveCount);

   If isright in Form1.DXInput.States then
        x:=x+2;
   If isleft in Form1.DXInput.States then
        x:=x-2;
   If isUp in Form1.DXInput.States then
        y:=y-2;
   If isDown in Form1.DXInput.States then
        y:=y+2;
   if isButton3 in Form1.DXInput.States then Angle:=Angle+2;
   if isButton4 in Form1.DXInput.States then Angle:=Angle-2;
    S:=' ';
       collision;
end;
  procedure THero.DoDraw;
   Begin
     image.drawrotate(form1.DXDraw.Surface,round(x)+16,round(y)+16,image.width,image.height,round(animpos),0.5,0.5,Angle);
   end;

  procedure Thero.DoCollision(Sprite: TSprite; var Done: Boolean);
   Begin
    if Sprite = Brix then S:='!';
   end;

procedure TForm1.DXTimerTimer(Sender: TObject; LagCount: Integer);
begin
   if not DXDraw.CanDraw then exit;

  DXInput.Update;
  DXSpriteEngine.Move(lagcount);
  DXSpriteEngine.Dead;

  DXDraw.Surface.Fill(0);
  DXSpriteEngine.draw;
   With DXDraw.Surface.Canvas do
  begin
    Brush.Style := bsClear;
    Font.Color := clWhite;
    Font.Size := 12;
    TextOut(0,0,'Q,W -  ');
    TextOut(0,20,' -  ');
    TextOut(0,40,S);
    Release;
    end;
  DXDraw.Flip;
end;

end.
